package org.pacemaker.controllers;

import java.util.ArrayList;
import java.util.List;

import org.pacemaker.R;
import org.pacemaker.main.PacemakerApp;
import org.pacemaker.main.SyncUpdate;
import org.pacemaker.models.Activity;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;


public class ActivitiesList extends  android.app.Activity implements SyncUpdate
{
  private PacemakerApp     app;
  private ListView         activitiesListView;
  private ActivityAdapter  activitiesAdapter;
  private List<Activity>   activities = new ArrayList<Activity>();
  
  @Override
  protected void onCreate(Bundle savedInstanceState)
  {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activities_list);
    
    app = (PacemakerApp) getApplication();

    activitiesListView = (ListView) findViewById(R.id.activitiesListView);
    activitiesAdapter = new ActivityAdapter(this,  activities);
    activitiesListView.setAdapter(activitiesAdapter);
    activitiesAdapter.activities = app.getActivities();
    activitiesAdapter.notifyDataSetChanged();
  }
  
  @Override
  public void userSyncComplete()
  { }

  @Override
  public void activitiesSyncComplete()
  { 
    activitiesAdapter.activities = app.getActivities();
    activitiesAdapter.notifyDataSetChanged();
  }

  @Override
  public void syncError(Exception e)
  {
    Toast toast = Toast.makeText(this, "Error Retrieving Activities...", Toast.LENGTH_SHORT);
    toast.show();
  } 

  @Override
  public boolean onCreateOptionsMenu(Menu menu)
  {
    getMenuInflater().inflate(R.menu.activities_list, menu);
    return true;
  }
  
  @Override
  public boolean onOptionsItemSelected(MenuItem item)
  {
    switch (item.getItemId())
    {
      case R.id.action_create_actvities : startActivity (new Intent(this, CreateActivity.class));
                                          break;                            
      case R.id.action_logout           : startActivity (new Intent(this, Welcome.class));
                                          break;     
    }
    return true;
  }
}

class ActivityAdapter extends ArrayAdapter<Activity>
{
  private Context        context;
  public  List<Activity> activities;

  public ActivityAdapter(Context context, List<Activity> activities)
  {
    super(context, R.layout.activity_row_layout, activities);
    this.context   = context;
    this.activities = activities;
  }

  @Override
  public View getView(int position, View convertView, ViewGroup parent)
  {
    LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
 
    View     view      = inflater.inflate(R.layout.activity_row_layout, parent, false);
    Activity activity  = activities.get(position);
    TextView type      = (TextView) view.findViewById(R.id.type);
    TextView location  = (TextView) view.findViewById(R.id.location);
    TextView distance  = (TextView) view.findViewById(R.id.distance);
    
    type.setText(activity.kind);
    location.setText(activity.location);
    distance.setText("" + activity.distance);
    return view;
  }

  @Override
  public int getCount()
  {
    return activities.size();
  }
}